/* Photoresistor
 * Fényérzékelés fotoellenállás (LDR) segítségével, 
 * amelyet egy feszültségosztó felső tagjának kötónk be.
 * 
 *          LDR      10k
 * VCC--/\/\/\-+-/\/\/\--- GND 
 *             |
 *             A3
 * 
 * A mért feszültség értékét a soros porton kiíratjuk.            
 */

void setup () {
   Serial.begin(9600);
   analogReference(DEFAULT);   //VCC a referencia
   Serial.print("Photoresistor");
}

void loop () {
   long reading = 0;
   for(int i=0; i<4750; i++) {
      reading += analogRead(A3);
   }
   float voltage = reading>>10;   //Osztás 1024-gyel
   Serial.print(voltage,0);
   Serial.print(" mV, ");
   // Átszámítás kOhm-ra
   // Rx = VCC*10k/voltage - 10k
   float rx = 47500/voltage - 10;
   Serial.print(rx,3);
   Serial.println(" kOhm");
   delay (5000);
}
