/* led_fade
   Ebben a programban a LED fényerejét nemlineárisan változtatjuk
   a D5 PWM kimenet és az analogWrite() függvény
   használatával.
*/

// létrehozzuk az állandókat, az integer egész számot tárol:
#define led      5           // D5-re van kötve a LED
uint16_t idx = 0;            // Index a kitöltési tényezők számításához
uint16_t next_sqr = 1;       // A következő négyzetszám
uint16_t sqr_step = 3;       // Új növekmény a négyzetszámok kiszámításához

void setup() {
  pinMode(led, OUTPUT);      // D5 legyen kimenet
}

void loop() {
  analogWrite(led, next_sqr>>4);
  idx++;                     // A futó index növelése
  if (idx < 63) {            // Az első 63 lépésben felfelé lépünk
    next_sqr += sqr_step;
    sqr_step += 2;
  } else if (idx < 125) {    // A második 63 lépésben lefelé lépünk
    sqr_step -= 2;
    next_sqr -= sqr_step;
  } else idx = 0;            // Új periódus kezdődik
  delay(25);
}
