/* led_pwm
 * Egy LED fényerejét változtatjuk egy potméter segítségével
 * az analogRead() és az analogWrite() függvény használatával.
 * 
 * Kapcsolás:
 * - Kössük egy potméter csúszkáját az A0 bemenetre (két végét
 *   pedig GND és +5V közé)!
 * - Kössük egy LED anódját a D5 kimenetre, katódját pedig  
 *   egy 470 ohmos áramkorlátozó ellenálláson keresztül GND-re!
 *                   ___________
 *                  |           |    LED   470R
 *         |--------| A0     D5 |----|>|--/\/\/\--- GND
 * +5V -/\/\/\- GND |           |       
 *       10K        |  Arduino  |
 */

// létrehozzuk az állandókat, az integer egész számot tárol:
const int led = 5;      // ide van kötve a LED

void setup() {
  // Nincs tennivaló
}

void loop() {
  int reading = analogRead(A0);
  analogWrite(led, reading>>2);
  // Várunk, hogy a szemünk is láthassa a változást:
  delay(50);
}
