/* timer_ledblink
 *  
 * Timer1 megszakítások ütemezésével villogtatjuk a 
 * beépített LED-et.
 * A soros porton másodpercenként kiíratjuk a Timer1
 * megszakítások számát.
 * 
 * A program forrása: TimerOne library mintapélda
 * https://github.com/PaulStoffregen/TimerOne
 */

#include <TimerOne.h>
#define led LED_BUILTIN
int ledState = LOW;
volatile unsigned long blinkCount = 0;

void setup(void) {
  pinMode(led, OUTPUT);
  Timer1.initialize(150000);         // Periódusidő = 0.15 s
  Timer1.attachInterrupt(blinkLED);  // Periódus végén blinkLED meghívása
  Serial.begin(9600);
}

void blinkLED(void) {                // Visszahívási függvény Timert1 megszakításhoz
  digitalWrite(led, ledState);       // LED állapot kijelzése
  ledState = !ledState;              // következő állapot ellentétes legyen (toggle)
  blinkCount++;                      // Megszakítások számlálása
}

void loop(void) {
  unsigned long blinkCopy;           // Ide másoljuk a számlálót
  noInterrupts();                    // Megszakítások ideiglenes tiltása
  blinkCopy = blinkCount;            // Másolat készítése  (kritikus szakasz)
  interrupts();                      // Megszakítások újraengedélyezése
  Serial.print("blinkCount = ");     // Megszakítások számának kiírása
  Serial.println(blinkCopy);
  delay(1000);                       // 1 másodpercenként írunk ki
}
